.TH ANN ann_FF_Jacobian "May 2001" "HRy" "ANN Toolbox"
.so ../sci.an
.SH NAME
ann_FF_Jacobian - computes Jacobian by finite differences.
.SH CALLING SEQUENCE
J = ann_FF_Jacobian(x,N,W,dx[,af])
.SH PARAMETERS
.TP
J
The Jacobian hypermatrix: each J(:,:,p) have same structure
as z(:,p)*x(:,p)', where z(:,p) is the network output given input
x(:,p).
.TP
x
Matrix of input patterns, one pattern per column.
.TP
N
Row vector describing the number of neurons per layer.
N(1) is the size of input pattern vector, N(size(N,'c')) is the size
of output pattern vector (and also target).
.TP
W
The weight hypermatrix.
.TP
dx
The quantity used to perturb each x(i,p) in turn.
.TP
af
The activation function to be used.

This parameter is optional, default value "ann_log_activ",
i.e. the logistic activation function.
.SH DESCRIPTION
This function calculates the Jacobian trough a finite differences
procedure, for all patterns presented in x.
.SH SEE ALSO
.TP
ANN
general overview of ANN toolkit.
.TP
ANN_GEN
general support functions.
.TP
ANN_FF
general description of feedforward nets and algorithms.
.SH AUTHOR
Ryurick M. Hristev <r.hristev@phys.canterbury.ac.nz>
