.TH ann_FF_grad_nb ANN "May 2001" "HRy" "ANN Toolbox"
.so ../sci.an
.SH NAME
ann_FF_grad_nb - error gradient trough finite differences
.SH CALLING SEQUENCE
grad_E = ann_FF_grad_nb(x,t,N,W,dW[,af,ef])
.SH PARAMETERS
.TP
grad_E
The error gradient, have same layout as W.
.TP
x
Input patterns, one per column.
.TP
t
Target patterns, one per column. Each column have a
correspondent column in x.
.TP
N
Row vector describing the number of neurons per layer.
N(1) is the size of input pattern vector, N(size(N,'c')) is the size
of output pattern vector (and also target).
.TP
W
The weight hypermatrix.
.TP
dW
The quantity used to perturb each W parameter. 
.TP
af
The activation function to be used.

This parameter is optional, default value "ann_log_activ",
i.e. the logistic activation function.
.TP
ef
The error function to be used.

This parameter is optional, default value "ann_sum_of_sqr",
i.e. the sum-of-squares error function.
.SH DESCRIPTION
Calculates error gradient trough a (slow) finite difference procedure.
Each element W(n,i,l) is changed to W(n,i,l)-dW then the error is
calculated and the process is repeated for W(n,i,l)+dW. From the
values obtained the partial derivative of the sum-of-squares error
function, with respect to W(n,i,l), is calculated and the value of
gradient returned.

This process is very slow (compared to the backpropagation algorithms)
so it is to be used only for testing purposes.

This function is to be used on networks without biases.
.SH SEE ALSO
.TP
ANN
general overview of ANN toolbox.
.TP
ANN_FF
general overview of supported feedforward nets and algorithms.
.SH AUTHOR
Ryurick M. Hristev <r.hristev@phys.canterbury.ac.nz>
