.TH ann_pat_shuffle ANN "May 2001" "HRy" "ANN Toolbox"
.so ../sci.an
.SH NAME
ann_pat_shuffle - shuffles randomly patterns for an ANN
.SH CALLING SEQUENCE
[x,t] = ann_pat_shuffle(x,t)
.SH PARAMETERS
.TP
x
Matrix containing the training inputs, one per column,
each column have a correspondent in t.
.TP
t
Matrix containing the targets, one per column,
each column have a correspondent in x.
.SH DESCRIPTION
This function randomly shuffles the columns in matrices x and t,
i.e. randomly shuffles the patterns. Some ANN train better if the
training set is presented repeatedly but in random order. This function
is intended to be called between two epochs. The
correspondence between the columns in x and t is preserved.

Note that x and t may change place, i.e. you may call this function as
"[t,x]=ann_pat_shuffle(t,x)" as long as you keep your order.
.SH SEE ALSO
.TP
ANN
general overview of ANN toolkit.
.TP
ANN_FF
general overview of supported feedforward nets and applications.
.SH AUTHOR
Ryurick M. Hristev <r.hristev@phys.canterbury.ac.nz>
