// Scilab 2.4 script

// WARNING THIS SCRIPT DOES NOT WORK WITH SCILAB 2.6 (UNDER INVESTIGATION)

// ART1 network to recognize various positions of a triangular shape

// Scilab initialization
clear;
rand('seed',0);
lines(40,120);

// the shapes are (#"1": 5,9,16,5,  8,9,21,25
// ..... .*... ..... ...*.   *.... ....* *.... ....*
// ..*.. .**.. ***** ..**.   .***. ...*. .*... .***.
// .***. .***. .***. .***.   ..**. ..**. .**.. .**..
// ***** .**.. ..*.. ..**.   ...*. .***. .***. .*...
// ..... .*... ..... ...*.   ....* *.... ....* *....
// note that the second set have one "*" less,
// this is unavoidable

// store inputs, one per column, patterns are read on rows
x = [ 0,0,0,0,0, ...
      0,0,1,0,0, ...
      0,1,1,1,0, ...
      1,1,1,1,1, ...
      0,0,0,0,0;
      0,1,0,0,0, ...
      0,1,1,0,0, ...
      0,1,1,1,0, ...
      0,1,1,0,0, ...
      0,1,0,0,0;
      0,0,0,0,0, ...
      1,1,1,1,1, ...
      0,1,1,1,0, ...
      0,0,1,0,0, ...
      0,0,0,0,0;
      0,0,0,1,0, ...
      0,0,1,1,0, ...
      0,1,1,1,0, ...
      0,0,1,1,0, ...
      0,0,0,1,0;
      1,0,0,0,0, ...
      0,1,1,1,0, ...
      0,0,1,1,0, ...
      0,0,0,1,0, ...
      0,0,0,0,1;
      0,0,0,0,1, ...
      0,0,0,1,0, ...
      0,0,1,1,0, ...
      0,1,1,1,0, ...
      1,0,0,0,0;
      1,0,0,0,0, ...
      0,1,0,0,0, ...
      0,1,1,0,0, ...
      0,1,1,1,0, ...
      0,0,0,0,1;
      0,0,0,0,1, ...
      0,1,1,1,0, ...
      0,1,1,0,0, ...
      0,1,0,0,0, ...
      1,0,0,0,0]';

// test patterns, data missing (last two rows)
x_test = x;
x_test(4:5,:) = zeros(2,8);

// ART1 parameters
N = size(x,'r');
K = size(x,'c');
beta = 1.01;
eta = 0.02;
d = 25;
ro = 0.99;

// number of patterns to learn in first stage
P1 = 4;

// initialize weights
W1 = (1 - (beta-1)/eta) * rand(N,K) + ((beta-1)/eta) * ones(N,K);
W2 = (d/(d-1+N)) * rand(K,N);

// initialize calibration data
// this will hold the winner for current index of "calibrated" vector
calibrated = zeros(K,1);

// hold winners on test data
win_on_test = zeros(K,1);

// -------------------------------------------------------------------
// learn first set of T vectors
for p = 1 : P1,
  // initialize list of inactive neurons 1 = active, 0 = inactive
  inactive = ones(K,1);
  // find winner (output of F_1 is x(:,p))
  [tmp,winner] = max(inactive .* (W2 * x(:,p)));
  // F_2_out is W2(:,winner)
  // find new F_1 output
  a_1_out = x(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
  F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
  // calculate the degree of match
  match = sum(F_1_out,'r')/sum(x(:,p),'r');
  while ro > match do ...
    // inactivate current winner
    inactive(winner) = 0;
    // restart
    [tmp,winner] = max(inactive .* (W2 * x(:,p)));
    a_1_out = x(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
    F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
    match = sum(F_1_out,'r')/sum(x(:,p),'r');
  end;
  // winner found, calibrate and update weights
  calibrated(p) = winner;
  W1(:,winner) = x(:,p);
  W2(winner,:) = d * x(:,p)'/(d-1+sum(x(:,p),'r'));
end;

// -------------------------------------------------------------------
// test first set
for p = 1 : P1,
  // initialize list of inactive neurons 1 = active, 0 = inactive
  inactive = ones(K,1);
  // find winner (output of F_1 is x_test(:,p))
  [tmp,winner] = max(inactive .* (W2 * x_test(:,p)));
  // F_2_out is W2(:,winner)
  // find new F_1 output
  a_1_out = x_test(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
  F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
  // calculate the degree of match
  match = sum(F_1_out,'r')/sum(x_test(:,p),'r');
  while ro > match do ...
    // inactivate current winner
    inactive(winner) = 0;
    // restart
    [tmp,winner] = max(inactive .* (W2 * x_test(:,p)));
    a_1_out = x_test(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
    F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
    match = sum(F_1_out,'r')/sum(x_test(:,p),'r');
  end;
  // winner found, calibrate and update weights
  win_on_test(p) = winner;
end;

// -------------------------------------------------------------------
// learn next K-P1 set of vectors
for p = P1 + 1 : K,
  // initialize list of inactive neurons 1 = active, 0 = inactive
  inactive = ones(K,1);
  // find winner (output of F_1 is x(:,p))
  [tmp,winner] = max(inactive .* (W2 * x(:,p)));
  // F_2_out is W2(:,winner)
  // find new F_1 output
  a_1_out = x(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
  F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
  // calculate the degree of match
  match = sum(F_1_out,'r')/sum(x(:,p),'r');
  while ro > match do ...
    // inactivate current winner
    inactive(winner) = 0;
    // restart
    [tmp,winner] = max(inactive .* (W2 * x(:,p)));
    a_1_out = x(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
    F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
    match = sum(F_1_out,'r')/sum(x(:,p),'r');
  end;
  // winner found, calibrate and update weights
  calibrated(p) = winner;
  W1(:,winner) = x(:,p);
  W2(winner,:) = d * x(:,p)'/(d-1+sum(x(:,p),'r'));
end;

// -------------------------------------------------------------------
// test second set
for p = P1 + 1 : K,
  // initialize list of inactive neurons 1 = active, 0 = inactive
  inactive = ones(K,1);
  // find winner (output of F_1 is x_test(:,p))
  [tmp,winner] = max(inactive .* (W2 * x_test(:,p)));
  // F_2_out is W2(:,winner)
  // find new F_1 output
  a_1_out = x_test(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
  F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
  // calculate the degree of match
  match = sum(F_1_out,'r')/sum(x_test(:,p),'r');
  while ro > match do ...
    // inactivate current winner
    inactive(winner) = 0;
    // restart
    [tmp,winner] = max(inactive .* (W2 * x_test(:,p)));
    a_1_out = x_test(:,p) + eta * (W1(:,winner)) - beta * ones(N,1);
    F_1_out = ones(N,1) - sign(ones(N,:) - sign(a_1_out));
    match = sum(F_1_out,'r')/sum(x_test(:,p),'r');
  end;
  // winner found, calibrate and update weights
  win_on_test(p) = winner;
end;

// print result
printf("Full sucess if calibrated is identical to win_on_test",1)
calibrated
win_on_test
