// Backpropagation network error surface example
// for figure F_bp_es_net3
// 2 neuron identity net: (1 input) 1 hidden, 1 output
// E = E(w1,w2)

// load XFig driver
driver('Fig');
current_driver=driver();

// define function
deff('[E]=surf(w1,w2)',...
     'E = 0.5 * ( ( 1+exp(-w2/2) )^(-2) ...
                  + ( 1 - 1/(1 + exp(-w2/(1+exp(-w1)) ) ) )^2 )');

// actual plot
xinit('my-figure.fig');
xbasc();

t=-10:1:10;
// upper-left subwindow
xsetech([0,0,0.5,0.5]);

// use gray shadings
xset("use color",0);

// pattern 10 gives dark blue for the grid in XFig
xset("pattern",10);
// angles 240,89 for first view
fplot3d1(t,t,surf,240,89,"w1@w2@E",[2,1,4],[-10,10,-10,10,0,0.8]);
// upper-right subwindow
xsetech([0.5,0,0.5,0.5])
// angles 280,89.5 for second view
fplot3d1(t,t,surf,280,89.5,"w1@w2@E",[2,1,4],[-10,10,-10,10,0,0.8]);
xend();
