// Inverse of the activation function in continous Hopfield memory
// f(y)=ln(x/(1-x))/(2*g)
// where g is the gain parameter
// for F_cont_hopfield_activ_func.fig

// load XFig driver
driver('Fig')
current_driver=driver()

// function definition
deff('[y]=f(x)','y=log(x/(1-x))/(2*g)')

// actual plot
xinit('cont_hopfield_inv_activ_func.fig');

// limits, discontinuity for x=0 and x=1
t=0.001:0.001:0.999;

g=1;
// draw also the axes and bounding box
fplot2d(t,f,[1],'011'," ",[0,-1,1,1])
g=3;
// draw just the additional curves 
fplot2d(t,f,[1],'000')
g=50;
fplot2d(t,f,[1],'000');
xend()
