// script to generate a 3d surface with contours for momentum
// for figure F_FEEDF_momentum.fig
// further processing is done in XFig afterwards

// load XFig driver
driver('Fig');
current_driver=driver();

xbasc();

// define function
deff('[p]=surf(x,y)','p=0.6*x^2 + 0.6*y^2 + 0.05*x*y + 0.7');

// actual plot
xinit('my-figure.fig')

// use color 0
xset("use color",0);

t = -1:0.2:1;
tc = -1:0.1:1;
my_box = [-1,1,-1,1,0,2.2];

// angles 110,65 for a good view
angle1 = 110;
angle2 = 65;
z = feval(t,t,surf);
zc = feval(tc,tc,surf);
contour(tc,tc,zc,[0.75,0.9,1.1,1.5],angle1,angle2,"x@y@f",[1,1,0],my_box);
plot3d(t,t,z,angle1,angle2,"x@y@f",[2,1,4],my_box);

xend();
