// plot graph of solution to passive decay differential equation
// for F_BND_passive_decay.fig

// load XFig driver
driver('Fig');
current_driver=driver();

xbasc();

// passive decay
deff('[y]=f(t)','y = %e^(-t)');

// actual plot
xinit('passive_decay.fig');

xsetech([0,0,0.5,0.5]);

// draw also the axes and bounding box
fplot2d(0:0.01:6,f,[1],'011'," ",[0,0,6,1],[1,6,1,10]);

xsetech([0.5,0,0.5,0.5]);

y0 = 1;
// passive decay with resting potential
deff('[y]=f(t)','y = y0 * %e^(-t) + 0.5 * (1 - %e^(-t))');

// draw also the axes and bounding box
fplot2d(0:0.01:6,f,[1],'011'," ",[0,0,6,1],[1,6,1,10]);

// draw just the additional curve
y0 = 0;
fplot2d(0:0.01:6,f,[1],'000');

xend();
