// Scilab 2.4 script

// WARNING THIS SCRIPT DOES NOT WORK UNDER SCILAB 2.6

// Traveling salesperson problem solved trough Hopfield continous net

clear;
lines(10000);
rand('seed',0);

// distances matrix, symmetrical, 0 on main diagonal
D = [ 0,  5,  7,  8,  1;
      0,  0,  4,  9,  6;
      0,  0,  0,  3, 10;
      0,  0,  0,  0,  2;
      0,  0,  0,  0,  0];

// build final D
D = D + D';

// number of cities, defined from D
K = size(D,'r');
KK = K^2;

// c_vector is used to build C matrix
c_vector = zeros(K,1);
c_vector(2) = 1;
c_vector(K) = 1;

// C matrix used in W (circulant)
C = toeplitz(c_vector,c_vector');

// tunning parameters
alpha = 0.2;
beta = 0.2;
gamma_0 = 0.2;
eta   = 0.01;

// no of training cycles
T = 80;

// first W term
W = - alpha * eye(K,K) .*. (ones(K,K) - eye(K,K));
// second W term
W = W - beta * (ones(K,K) - eye(K,K)) .*. eye(K,K);
// third W term
W = W - gamma_0 * ones(KK,KK);
// fourth W term
W = W - eta * D .*. C;

// x vector
x = gamma_0 * K * ones(KK,1);

// initialize a and y
y = 0.01 * rand(KK,1);
delta_a = zeros(KK,1);

// main loop
for t = 1 : T
  delta_a = delta_a + W * y + x;
  y = (ones(KK,1) + tanh(delta_a))/2;
end;

// print results
printf("Actual output:",1)
Y = matrix(y,K,K)'
printf("Trend:",1)
ceil(clean(Y,0.5))
